org.keycloak.protocol.oidc.mappers

## Class AbstractOIDCProtocolMapper

- java.lang.Object
- - org.keycloak.protocol.oidc.mappers.AbstractOIDCProtocolMapper

- All Implemented Interfaces:
    ProtocolMapper, ConfiguredProvider, Provider, ProviderFactory<ProtocolMapper>
  Direct Known Subclasses:
    AbstractPairwiseSubMapper, AddressMapper, AllowedWebOriginsProtocolMapper, AudienceProtocolMapper, AudienceResolveProtocolMapper, ClaimsParameterTokenMapper, FullNameMapper, GroupMembershipMapper, HardcodedClaim, HardcodedRole, RoleNameMapper, ScriptBasedOIDCProtocolMapper, UserAttributeMapper, UserClientRoleMappingMapper, UserPropertyMapper, UserRealmRoleMappingMapper, UserSessionNoteMapper

      public abstract class AbstractOIDCProtocolMapper
      extends Object
      implements ProtocolMapper

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `TOKEN_MAPPER_CATEGORY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractOIDCProtocolMapper()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` This is called when the server shuts down.
    `ProtocolMapper` | `create(KeycloakSession session)`
    `String` | `getProtocol()`
    `void` | `init(Config.Scope config)` Only called once when the factory is first created.
    `void` | `postInit(KeycloakSessionFactory factory)` Called after all provider factories have been initialized
    `protected void` | `setClaim(AccessTokenResponse accessTokenResponse, ProtocolMapperModel mappingModel, UserSessionModel userSession, KeycloakSession keycloakSession, ClientSessionContext clientSessionCtx)` Intended to be overridden in `ProtocolMapper` implementations to add claims to an token.
    `protected void` | `setClaim(IDToken token, ProtocolMapperModel mappingModel, UserSessionModel userSession)` Deprecated. override `setClaim(IDToken, ProtocolMapperModel, UserSessionModel, KeycloakSession, ClientSessionContext)` instead.
    `protected void` | `setClaim(IDToken token, ProtocolMapperModel mappingModel, UserSessionModel userSession, KeycloakSession keycloakSession, ClientSessionContext clientSessionCtx)` Intended to be overridden in `ProtocolMapper` implementations to add claims to an token.
    `AccessToken` | `transformAccessToken(AccessToken token, ProtocolMapperModel mappingModel, KeycloakSession session, UserSessionModel userSession, ClientSessionContext clientSessionCtx)`
    `AccessTokenResponse` | `transformAccessTokenResponse(AccessTokenResponse accessTokenResponse, ProtocolMapperModel mappingModel, KeycloakSession session, UserSessionModel userSession, ClientSessionContext clientSessionCtx)`
    `IDToken` | `transformIDToken(IDToken token, ProtocolMapperModel mappingModel, KeycloakSession session, UserSessionModel userSession, ClientSessionContext clientSessionCtx)`
    `AccessToken` | `transformUserInfoToken(AccessToken token, ProtocolMapperModel mappingModel, KeycloakSession session, UserSessionModel userSession, ClientSessionContext clientSessionCtx)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.keycloak.protocol.ProtocolMapper

      `getDisplayCategory, getDisplayType, getPriority, validateConfig`

    - ### Methods inherited from interface org.keycloak.provider.ProviderFactory

      `getId, order`

    - ### Methods inherited from interface org.keycloak.provider.ConfiguredProvider

      `getConfigProperties, getHelpText`

- - ### Field Detail

    - #### TOKEN_MAPPER_CATEGORY

          public static final String TOKEN_MAPPER_CATEGORY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AbstractOIDCProtocolMapper

          public AbstractOIDCProtocolMapper()

  - ### Method Detail

    - #### getProtocol

          public String getProtocol()

      Specified by:
        `getProtocol` in interface `ProtocolMapper`

    - #### close

          public void close()

      Description copied from interface: `ProviderFactory`
      This is called when the server shuts down.
      Specified by:
        `close` in interface `Provider`
      Specified by:
        `close` in interface `ProviderFactory<ProtocolMapper>`

    - #### create

          public final ProtocolMapper create(KeycloakSession session)

      Specified by:
        `create` in interface `ProviderFactory<ProtocolMapper>`

    - #### init

          public void init(Config.Scope config)

      Description copied from interface: `ProviderFactory`
      Only called once when the factory is first created. This config is pulled from keycloak_server.json
      Specified by:
        `init` in interface `ProviderFactory<ProtocolMapper>`

    - #### postInit

          public void postInit(KeycloakSessionFactory factory)

      Description copied from interface: `ProviderFactory`
      Called after all provider factories have been initialized
      Specified by:
        `postInit` in interface `ProviderFactory<ProtocolMapper>`

    - #### transformUserInfoToken

          public AccessToken transformUserInfoToken(AccessToken token,
                                                    ProtocolMapperModel mappingModel,
                                                    KeycloakSession session,
                                                    UserSessionModel userSession,
                                                    ClientSessionContext clientSessionCtx)

    - #### transformAccessToken

          public AccessToken transformAccessToken(AccessToken token,
                                                  ProtocolMapperModel mappingModel,
                                                  KeycloakSession session,
                                                  UserSessionModel userSession,
                                                  ClientSessionContext clientSessionCtx)

    - #### transformIDToken

          public IDToken transformIDToken(IDToken token,
                                          ProtocolMapperModel mappingModel,
                                          KeycloakSession session,
                                          UserSessionModel userSession,
                                          ClientSessionContext clientSessionCtx)

    - #### transformAccessTokenResponse

          public AccessTokenResponse transformAccessTokenResponse(AccessTokenResponse accessTokenResponse,
                                                                  ProtocolMapperModel mappingModel,
                                                                  KeycloakSession session,
                                                                  UserSessionModel userSession,
                                                                  ClientSessionContext clientSessionCtx)

    - #### setClaim

          @Deprecated
          protected void setClaim(IDToken token,
                                              ProtocolMapperModel mappingModel,
                                              UserSessionModel userSession)

      Deprecated. override `setClaim(IDToken, ProtocolMapperModel, UserSessionModel, KeycloakSession, ClientSessionContext)` instead.
      Intended to be overridden in `ProtocolMapper` implementations to add claims to an token.
      Parameters:
        `token` -
        `mappingModel` -
        `userSession` -

    - #### setClaim

          protected void setClaim(IDToken token,
                                  ProtocolMapperModel mappingModel,
                                  UserSessionModel userSession,
                                  KeycloakSession keycloakSession,
                                  ClientSessionContext clientSessionCtx)

      Intended to be overridden in `ProtocolMapper` implementations to add claims to an token.
      Parameters:
        `token` -
        `mappingModel` -
        `userSession` -
        `keycloakSession` -
        `clientSessionCtx` -

    - #### setClaim

          protected void setClaim(AccessTokenResponse accessTokenResponse,
                                  ProtocolMapperModel mappingModel,
                                  UserSessionModel userSession,
                                  KeycloakSession keycloakSession,
                                  ClientSessionContext clientSessionCtx)

      Intended to be overridden in `ProtocolMapper` implementations to add claims to an token.
      Parameters:
        `accessTokenResponse` -
        `mappingModel` -
        `userSession` -
        `keycloakSession` -
        `clientSessionCtx` -

Copyright © 2021 JBoss by Red Hat. All rights reserved.